% 
% Generating the spectrum of MFSK
% Author: M. Fitz
% Last modified: 1/28/04
% 
close all
clear all
numpts=2048;
K_b=3;
M=2^K_b;
f_d=0.25;
freq=linspace(-4-M/2,4+M/2, numpts+1);
g_pr=zeros(1,numpts+1);
figure(1)
hold on
for kk=0:M-1
	dum1=sinc(freq-(2*kk-M+1)*f_d*ones(1,numpts+1)).^2;
	dumdb=10*log10(dum1);
	plot(freq,dumdb,'r:')
	g_pr=g_pr+dum1;
end
g_prdb=10*log10(g_pr/(M*K_b));
plot(freq,g_prdb)
axis([-4-M/2 4+M/2 -50 5])
xlabel('Normalized frequency, fT_p')
ylabel('Normalized energy spectrum per bit')
hold off
