% 
% Generating the spectrum of OFDM
% Author: M. Fitz
% Last modified: 9/24/01
% 
close all
clear all
numpts=2048;
K_b=4;
freq=linspace(-6-K_b/2+eps,6+K_b/2, numpts+1);
g_pr=zeros(1,numpts+1);
figure(1)
hold on
%
% Spreading signal 1
%
s1f=sinc(freq).^2;
dumdb=10*log10(s1f);
plot(freq,dumdb,'r:')
g_pr=g_pr+s1f;
%
% Spreading signal 2
%
s2f=(sqrt(0.5)*sinc(freq/2).*exp(j*pi/2*freq)-sqrt(0.5)*sinc(freq/2).*exp(j*3*pi/2*freq)).^2;
dumdb=10*log10(s2f);
plot(freq,dumdb,'b:')
g_pr=g_pr+s2f;
%
% Spreading signal 3
%
s3f=(sqrt(0.25)*sinc(freq/4).*exp(j*pi/4*freq)-sqrt(0.5)*sinc(freq/2).*exp(j*pi*freq)+sqrt(0.25)*sinc(freq/4).*exp(j*7*pi/4*freq)).^2;
dumdb=10*log10(s3f);
plot(freq,dumdb,'g:')
g_pr=g_pr+s3f;
%
% Spreading signal 4
%
s4f=(sqrt(0.25)*sinc(freq/4).*exp(j*pi/4*freq)-sqrt(0.25)*sinc(freq/4).*exp(j*3*pi/4*freq)+sqrt(0.25)*sinc(freq/4).*exp(j*5*pi/4*freq)-sqrt(0.25)*sinc(freq/4).*exp(j*7*pi/4*freq)).^2;
dumdb=10*log10(s4f);
plot(freq,dumdb,'k:')
g_pr=g_pr+s4f;
%
%  Plotting total spectrum
%
g_prdb=10*log10(g_pr);
plot(freq,g_prdb)
axis([-6-K_b/2 6+K_b/2 -50 10])
xlabel('Normalized frequency, fT_p')
ylabel('Normalized energy spectrum per bit')
hold off
