% 
% Generating the time waveform of OCDM
% Author: M. Fitz
% Last modified: 8/23/02
% 
close all
clear all
numpts=2048;
K_b=4;
T_p=1;
time=linspace(0,T_p, numpts+1);
%
% Spreading waveform 1
%
s(1,:)=ones(1, numpts+1);
%
% Spreading waveform 2
%
s(2,:)=ones(1, numpts+1);
i2=find(time>0.5);
s(2,i2)=-ones(size(i2));
%
% Spreading waveform 3
%
s(3,:)=ones(1, numpts+1);
i3a=find(time>0.25&time<=0.5);
s(3,i3a)=-ones(size(i3a));
i3b=find(time>0.75);
s(3,i3b)=-ones(size(i3b));
%
% Spreading waveform 4
%
s(4,:)=ones(1, numpts+1);
i4a=find(time>0.75);
s(4,i4a)=-ones(size(i4a));
i4b=find(time<=0.25);
s(4,i4b)=-ones(size(i4b));
x_z=zeros(2,numpts+1);
for ll=1:2
for kk=1:K_b
    d_z(kk)=sign(rand(1)-0.5);
	wavekk=d_z(kk)*s(kk,:);
	x_z(ll,:)=x_z(ll,:)+wavekk;
end
d_z
end
hs=subplot(1,1,1);
set(hs,'Fontsize',14);
xlabel('x_I(t)','Fontsize',16)
ylabel('x_Q(t)','Fontsize',16)
x_a=abs(x_z);
figure(2)
plot(time, x_a(1,:),time, x_a(2,:),'b--')
hs=subplot(1,1,1);
set(hs,'Fontsize',14);
xlabel('Normalized time, t/T_p','Fontsize',16)
ylabel('x_A(t)','Fontsize',16)
axis([0 1 0 5])
legend('I=i_1','I=i_2')
