clear all
close all
k_s=1;
n_b=1;
n_s=4;
m_s=4;
numedges=2^(k_s)*n_s;
nu_c=2;
ilabel=linspace(0,numedges-1,numedges)';
%
% Last two bits define state
%
isym2=floor((ilabel)/4);
isym1=floor((ilabel-isym2*4)/2);
isym0=floor((ilabel-isym2*4-isym1*2));
%
% Calculating the transmitted symbols for each edge
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 4 state HCV code
%
% The convention is that the latest bit is the least significant bit of
% the definition
% HCV is a feedforward code
g1=isym1*2+isym0+1;
% 
% Defining constellation points and g2
%
d=[-3/sqrt(5) -1/sqrt(5) 1/sqrt(5) 3/sqrt(5)]; 
g2=[d(1) d(3) d(4) d(2) d(3) d(1) d(2) d(4)]';
%
% Termination
% term is [n_s x nu_c]
%
term=[d(1) d(1); d(4) d(3); d(3) d(1); d(2) d(3)];
%
% Defining Transitions to simplify the VA
% Mapping from state and data to trellis edge enumeration
% g4=[n_s x 2]
%
g4=[1 5; 2 6; 3 7; 4 8];
%
% Defining Transitions to simplify the VA
% Mapping from state and pointer to previous state
% g5=[n_s x 2]
%
g5=[1 3; 1 3; 2 4; 2 4];
%
% Defining Transitions to simplify the VA
% Mapping from state and pointer to information bits
% g6=[n_s x 2]
%
g6=[0 0; 1 1; 0 0; 1 1];
%
% Defining Transitions to simplify the Sequential decoder
% Mapping from state and previous state to pointer
% g7=[n_s x n_s]
%
g7=[1 0 2 0; 1 0 2 0; 0 1 0 2; 0 1 0 2];
save tcmdef g1 g2 term g4 g5 g6 g7 nu_c
 