

% 
% m-file which implements a large carrier amplitude 
% demodulation algorithm
%  
%
% Author: M. Fitz
% Last modified: 9/26/99
%
load lcam
% lcam.mat is a file containing variables mess, xc, f_c, and fs
% xc is the DSB-AM modulated signal
% mess is a filtered computer generated voice saying "bingo"
% mess was generated by truncating m in Chap1Ex2.m
% f_c is the carrier frequency
% fs=sampling rate 22050Hz
% xc has 16384 samples
% mess has 16384 samples
[ilength jlength]=size(mess);
% time variable is the sample number times the sample period
time=(0:16383)/fs;
% 
% Implementing the ideal EE501 channel
% y_c(t)=x_c(t-\tau_p)
% Implement a delay of one symbol (for example)
%
sigma=1.0;
yc=transpose([0; xc(1:16383)]);%+sigma*randn(1,16384);
figure(1)
plot(time,yc)
title('Received LC-AM signal')
xlabel('time, seconds')
%ylabel('y_c(t)')
% 
% Implementing a quadrature demodulator
%
deltaf=100;
ytildei=sqrt(2).*cos(2*pi*(f_c-deltaf)*time).*yc;
ytildeq=-sqrt(2).*sin(2*pi*(f_c-deltaf)*time).*yc;
% 
%Implementing the lowpass filters
% 
% bw=one-sided bandwidth in Hz
% length=impulse response length in samples
% length must be an even number
bw=4000;
length=512;
time2=(0:length)/fs;
half=length/2/fs;
%
% impulse response of an ideal bandpass filter truncated length
%
ht=2*bw*sinc(2*bw*(time2-half));
%
% filtering
%
yi=conv(ht,ytildei)/2/bw;
yq=conv(ht,ytildeq)/2/bw;
%
% Truncating to a length 16384
%
yz=yi(1:16384)+j*yq(1:16384);
ya=abs(yz);
figure(2)
%plot(time,yi(1:16384), time, yq(1:16384))
plot(time, ya)
title('Amplitude of the received complex envelope')
xlabel('time, t')
%ylabel('y_A(t)')
%axis([-8 8 -8 8])
%
% Computing the DC value of the signal
%
%
% Implementing a sliding window accumulator
% lenref=length of the sliding window
% lenref must be even
%
lenref=300;
href=ones(1,lenref)/lenref;
ydc=conv(ya,href);
mhat=ya-ydc(1:16384);
figure(3)
%plot(time,yi(1:16384), time, yq(1:16384))
plot(time, mhat)
title('Noncoherently demodulated LC-AM signal')
xlabel('time, t')
soundsc(mess,fs)
%
% Normalizing output signal
%
soundsc(mhat,fs)
