

% 
% m-file which implements a angle demodulator
%  
%
% Author: M. Fitz
% Last modified: 10/6/99
%
load pm
% pm.mat is a file containing variables mess, xc, f_c, and fs
% xc is the phase modulated signal
% mess is a filtered computer generated voice saying "bingo"
% mess was generated by truncating m in Chap1Ex2.m
% f_c is the carrier frequency
% fs=sampling rate 22050Hz
% xc has 16384 samples
% mess has 16384 samples
[ilength jlength]=size(mess);
% time variable is the sample number times the sample period
time=(0:16383)/fs;
% 
% Implementing the ideal EE501 channel
% y_c(t)=x_c(t-\tau_p)
% Implement a delay of one symbol (for example)
% \phi_p=-114 degrees
%
%yc=transpose(xc);
yc=transpose([0; xc(1:16383)]);
%
% Adding noise
%
%sigma=0.2;
%yc=transpose([0; xc(1:16383)])+sigma*randn(1,16384);
figure(1)
plot(time,yc)
title('Received PM signal')
xlabel('time, seconds')
%ylabel('y_c(t)')
% 
% Implementing a quadrature demodulator
%
deltaf=0;
ytildei=sqrt(2).*cos(2*pi*(f_c-deltaf)*time).*yc;
ytildeq=-sqrt(2).*sin(2*pi*(f_c-deltaf)*time).*yc;
% 
%Implementing the lowpass filters
% 
% bw=one-sided bandwidth in Hz
% length=impulse response length in samples
% length must be an even number
bw=2000;
length=512;
time2=(0:length)/fs;
half=length/2/fs;
%
% impulse response of an ideal bandpass filter truncated length
%
ht=2*bw*sinc(2*bw*(time2-half));
%
% filtering
%
yi=conv(ht,ytildei)/2/bw;
yq=conv(ht,ytildeq)/2/bw;
%
% Truncating to a length 16384
%
yz=yi(1:16384)+j*yq(1:16384);
figure(2)
%plot(time(1001:16384),yi(1001:16384), time(1001:16384), yq(1001:16384))
plot(yi(1001:16384),yq(1001:16384))
title('Vector diagram output for received complex envelope')
xlabel('In-Phase Component')
ylabel('Quadrature Component')
%axis([-3 3 -3 3])
%
%  Implementing a direct phase detector
%
phase=angle(yz);
figure(3)
plot(time(5001:5513),phase(5001:5513))
title('Direct detected phase')
xlabel('time')
ylabel('Phase')
%
% Unwrapping phase and ignoring the initial transients
%
figure(4)
uphase=unwrap(phase(1001:16384));
plot(time(5001:5513),uphase(5001:5513))
title('Unwrapped phase')
xlabel('time')
ylabel('Phase')
% 
%Implementing the lowpass filters
% 
% bw=one-sided bandwidth in Hz
% length=impulse response length in samples
% length must be an even number
bw=2500;
length=512;
time2=(0:length)/fs;
half=length/2/fs;
%
% impulse response of an ideal bandpass filter truncated length
%
hpd=2*bw*sinc(2*bw*(time2-half));
%
% filtering
%
ydl=conv(hpd,uphase)/2/bw;
%axis([-8 8 -8 8])
%mhat=real(demod);
%
% Computing the DC value of the signal
%
%
% Implementing a sliding window accumulator
% lenref=length of the sliding window
% lenref must be even
%
lenref=300;
href=ones(1,lenref)/lenref;
ydc=conv(uphase,href);
ydc2=conv(ydl,href);
mhat1=uphase-ydc(1:15384);
mhat2=ydl-ydc2(1:15896);
figure(5)
plot(time(5001:5513),mhat2(5001:5513))
title('Demodulated signal')
xlabel('time')
ylabel('output')
soundsc(mess,fs)
%
% Normalizing output signal
%
soundsc(mhat2,fs)
%soundsc(mhat2,fs)
figure(5)
plot(time(5001:15384),mhat2(5001:15384))
title('Demodulated signal')
xlabel('time')
ylabel('output')
