% 
% Generating the time waveform of stream modulation
% Author: M. Fitz
% Last modified: 7/28/03
% 
close all
clear all
numptstp=2048;
K_b=64;
numptsu=numptstp/K_b;
numptsth=numptsu;
totpts=numptstp+numptsth;
T_u=0.25;
T_p=1;
%
% Pulse Shape
%
u=ones(1,numptsu);
%  An example channel
%
%  Computing the tilde pulse
utilde=zeros(1,numptsu+numptsth);
%alpha_1=0.7*exp(j*pi/3);
alpha_1=0.7*exp(j*pi/180);
alpha_0=sqrt(1-abs(alpha_1)^2);
utilde(1:numptsu)=utilde(1:numptsu)+alpha_0*u;
utilde(numptsth+1:numptsth+numptsu)=utilde(numptsth+1:numptsth+numptsu)+alpha_1*u;
%
% Computing the G matrix
%
gr=zeros(1,K_b);
eb=1;
gr(1)=1;
gr(2)=conj(alpha_0)*alpha_1/eb;
[abs(gr(2)) angle(gr(2))/pi*180]
%G=toeplitz(gr)
  	
%
%  Computing the received signal
%
r_z=zeros(1,totpts);
for ll=1:K_b
	d_z(ll)=sign(rand(1)-0.5);	
%
%  Computing the received signal
%
	r_z(numptsu*(ll-1)+1:numptsu*ll+numptsth)=r_z(numptsu*(ll-1)+1:numptsu*ll+numptsth)+utilde*d_z(ll);
end
%
%  Computing the matched filter
%
mfimp=fliplr(conj(utilde));
qtilde=conv(r_z,mfimp)/(eb*numptsu);
figure(1)
plot(abs(qtilde))
figure(2)
hold on
for ll=1:K_b
	plot(qtilde((ll-1)*numptsu+numptsu+numptsth),'ro')
	axis([-2 2 -2 2])
end
hold off
