

% 
% m-file which plays with noise
%  
%
% Author: M. Fitz
% Last modified: 11/10/99
%
fs=22050;
ilength=8192;
time=(0:ilength-1)/fs;
sigma=1.0;
sigma2=2*(0:ilength-1)/ilength;
w=sigma*randn(1,ilength);
w1=sigma2.*randn(1,ilength);
soundsc(w)
figure(1)
plot(time,w)
title('Noise')
xlabel('time, seconds')
% 
figure(2)
plot(time,w1)
title('Noise-Nonstationary')
xlabel('time, seconds')
%looking at frequency domain
wfs=fft(w)/fs;
wf=fftshift(wfs);
%
% Computing output PSD
%
psdw=wf.*conj(wf)/ilength*fs;
psdwdb=10*log10(psdw);
% frequency variable
freq=(-ilength/2:ilength/2-1)/ilength*fs;
figure(3)
plot(freq,psdwdb)
axis([-fs/2 fs/2 -80 -30])
title('Measured Power spectrum input noise')
xlabel('Frequency, Hertz')
% 
%Implementing the lowpass filters
% 
% bw=one-sided bandwidth in Hz
% length=impulse response length in samples
% length must be an even number
bw=4000;
length=512;
time2=(0:length)/fs;
half=length/2/fs;
%
% impulse response of an ideal bandpass filter truncated length
%
ht=2*bw*sinc(2*bw*(time2-half));
%
% filtering
%
nout=conv(w,ht)/fs;
n=nout(1:8192);
soundsc(n)
%
% Plotting filtered output noise
%
figure(4)
plot(time,n)
title('Filtered noise')
xlabel('Time')
ylabel('N(t)')
%
% Plotting a comparison over a smaller time scale
%
figure(5)
plot(time(1000:1200),w(1000:1200),'b-',time(1000:1200),n(1000:1200),'k-')
h=plot(time(1000:1200),w(1000:1200),'b-',time(1000:1200),n(1000:1200),'k-');
set(h,'linewidth', 2.0)
axis([0.046 0.054 -3 3])
%looking at frequency domain
nfs=fft(n)/fs;
nf=fftshift(nfs);
%
% Computing output PSD
%
psdn=nf.*conj(nf)/ilength*fs;
psdndb=10*log10(psdn);
% frequency variable
freq=(-ilength/2:ilength/2-1)/ilength*fs;
figure(6)
plot(freq,psdndb)
axis([-5000 5000 -80 -30])
title('Measured Power spectrum output noise')
xlabel('Frequency, Hertz')
