
% 
% m-file which plays with noise
%  Gaussianity
%  Moments-mean and covariance
%  Stationarity
%
%  
%
% Author: M. Fitz
% Last modified: 11/27/00
%
clear all
close all
fs=22050;
ilength=8192;
time=(0:ilength-1)/fs;
sigma=1.0;
sigma2=2*(0:ilength-1)/ilength;
%
% Viewing one sample function of the noise
%
w=sigma*randn(1,ilength);
w1000(1)=w(1000);
w1=sigma2.*randn(1,ilength);
w11000(1)=w1(1000);
soundsc(w)
soundsc(w1)
figure(1)
subplot(1,2,1), plot(time,w)
title('Noise, W(t)')
xlabel('time, seconds')
subplot(1,2,2), plot(time,w1)
title('Noise-Nonstationary, W(t)')
xlabel('time, seconds')
wtot=w;
w2tot=w.*w;
w1tot=w1;
w12tot=w1.*w1;
figure(2)
subplot(3,2,1), plot(time,wtot)
title('Average value of the noise, stationary')
%xlabel('time, seconds')
axis([0 0.3 -2 2])
subplot(3,2,2), plot(time,w1tot)
title('Average value of the noise, non-stationary')
%xlabel('time, seconds')
axis([0 0.3 -2 2])
subplot(3,2,3), plot(time,w2tot)
title('Average value of the square of the noise, stationary')
xlabel('time, seconds')
axis([0 0.3 0 4])
subplot(3,2,4), plot(time,w12tot)
title('Average value of the square of the noise, non-stationary')
xlabel('time, seconds')
axis([0 0.3 0 4])
subplot(3,2,5), hist(w1000,50)
subplot(3,2,6), hist(w11000,50)
pause
%
% Looking at multiple sample functions of the noise
% to compute some empirical averages
%
for ii=1:4000
 w=sigma*randn(1,ilength);
 w1000(ii+1)=w(1000);
 w1=sigma2.*randn(1,ilength);
 w11000(ii+1)=w1(1000);
 wtot=w+wtot;
 w2tot=w.*w+w2tot;
 w1tot=w1+w1tot;
 w12tot=w1.*w1+w12tot;
 figure(2)
 if mod(ii,250)==0
   ii
   subplot(3,2,1), plot(time,wtot/(ii+1))
   title('Average value of the noise, stationary')
   %xlabel('time, seconds')
   axis([0 0.3 -2 2])
   subplot(3,2,2), plot(time,w1tot/(ii+1))
   title('Average value of the noise, non-stationary')
   %xlabel('time, seconds')
   axis([0 0.3 -2 2])
   subplot(3,2,3), plot(time,w2tot/(ii+1))
   title('Average value of W^2(t), stationary')
   xlabel('time, seconds')
   axis([0 0.3 0 4])
   subplot(3,2,4), plot(time,w12tot/(ii+1))
   title('Average value of W^2(t), non-stationary')
   xlabel('time, seconds')
   axis([0 0.3 0 4])
   subplot(3,2,5), hist(w1000,50)
   subplot(3,2,6), hist(w11000,50)
   pause(0.5)
 end 
end
